#!/usr/bin/python
# -*- coding: iso8859-1 -*-
'''
summary: simple config file (a-la .ini) helper
by: Fabius @ 20090328
license: Free

\note
  In pratica serve a semplificare un pochetto le operazioni di gestione dei file di configurazione - basta occuparsi di specificare il file di config e chiamare set per settare o eliminare un opzione e get per leggere un valore.
  NB: i valori sono sempre su un'unica riga!
'''

import os, re, sys
import ConfigParser as cp

#=============================================================================
# CLASSES
#=============================================================================
class confed(cp.SafeConfigParser):
  #---------------------------------------------------------------------
  #
  def __init__(self, configfile):
    cp.SafeConfigParser.__init__(self)
    configfile=os.path.expanduser(configfile)
    self._cfgfile=os.path.abspath(configfile)
    configpath=os.path.dirname(self._cfgfile)
    if not os.path.isdir(configpath): os.makedirs(configpath)
    if os.path.isfile(self._cfgfile): self.read(self._cfgfile)
    ###else:
      ###if __debug__:
        ###print "[confed] config file '%s' not found!" % self._cfgfile
      ###self._cfgfile=None
  #---------------------------------------------------------------------
  #
  def set(self, section, option, value=''):
    if not self.has_section(section): self.add_section(section)
    cp.SafeConfigParser.set(self,
      section,
      option,
      self.encodestring(value)
    )
    self.write(open(self._cfgfile,'w'))
  #---------------------------------------------------------------------
  #
  def get(self, section, option, default=""):
    if not self.has_section(section):
      if __debug__:
        print "[confed] section '%s' not found in '%s'!"% (
          section, self._cfgfile
        )
      return default
    else:
      if self.has_option(section, option):
        return self.decodestring(cp.SafeConfigParser.get(self, section, option))
      else: return default
  #---------------------------------------------------------------------
  #
  def decodestring(self, s):
    s=s.strip('"')
    s=s.replace('\\n', "\n")
    s=s.replace('\"', '"')
    return s
  #---------------------------------------------------------------------
  #
  def encodestring(self, s):
    s=s.replace("\n", '\\n')
    s=s.replace('"', '\"')
    return '"'+s+'"'
  #---------------------------------------------------------------------
  #
  def exists(self): return self._cfgfile
