# -*- coding: iso8859-1 -*-
'''
Simple text tag translation facility
'''
from confed import *
#======================================================================
#
default_db=None
alt_db=None
#======================================================================
#
class transtext(object):
  forms={
    'n': lambda x: x,
    'l': lambda x: x.lower(),
    'u': lambda x: x.upper(),
    'c': lambda x: x.capitalize(),
    't': lambda x: x.title(),
  }
  def __init__(self,
    default, inuse=None, default_section='Generic', default_form="n"
  ):
    self.lang_default=confed(default)
    self.default_section=default_section
    self.set_inuse(inuse)
    self.default_form=default_form
  #----------------------------------------------------------------
  #
  def gettext(self, textid, form="", section=None):
    '''return the definition in inuse dictionary or in the default if fails or textid if fails
    '''
    form=form if form else self.default_form
    section=section if section else self.default_section
    t=self.lang_inuse.get(section, textid)
    if not t:
      t=self.lang_default.get(section, textid)
      if not t: t=textid
    return transtext.forms[form](t)
  #----------------------------------------------------------------
  #
  def set_inuse(self, inuse):
    try: self.lang_inuse=confed(inuse)
    except: self.lang_inuse=self.lang_default
#======================================================================
#======================================================================
_dict=None
def set_dictionary(default="language.en", inuse=None, default_section='Generic', default_form="l"):
  global _dict
  _dict=transtext(default=default, inuse=inuse,
    default_section=default_section, default_form=default_form
  )
  return _dict.gettext
