'''
by: fabius astelix @ 2009-04
revisers:
summary: shows models and animated actors
'''
from direct.showbase.DirectObject import DirectObject
from pandac.PandaModules import DirectionalLight, VBase4
from direct.actor import Actor
import direct.directbase.DirectStart

class World(DirectObject):
  def __init__(self, model_file='slim-panda-lod1', animation_file=''):
    dlight = DirectionalLight('dlight')
    dlight.setColor(VBase4(0.8, 0.8, 0.9, 1))
    dlnp = base.render.attachNewNode(dlight)
    dlnp.setHpr(0, -60, 0)
    render.setLight(dlnp)
    #
    if animation_file:
      self.subject = Actor.Actor(model_file,
        {"anim8":animation_file})
      self.subject.reparentTo(base.render)
      self.subject.loop("anim8")
    else:
      self.subject=base.loader.loadModel(model_file)
    #
    self.subject.setScale(0.25,0.25,0.25)
    self.subject.setPos(0, 4, -.5)
